import urllib, urllib2, os.path, StringIO, base64
from xml.dom.minidom import parse, parseString

def getContent(ID):
    filename = os.path.join("temp", "%d.xml" % ID)
    if os.path.isfile(filename):
        f = open(filename, "rb")
        r = f.read()
        f.close()
        return r
    url = "http://api.openstreetmap.org/api/0.5/way/%d" % ID
    c = urllib.urlopen(url).read()
    f = open(filename, "wb")
    r = f.write(c)
    f.close()
    return c
    
def sendResult(ID, xml):
    base64string = base64.encodestring('%s:%s' % ('username', 'password'))[:-1]
    req = urllib2.Request('http://api.openstreetmap.org/api/0.5/way/%d?_method=put' % ID)
    req.add_header("Authorization", "Basic %s" % base64string)

    handle = urllib2.urlopen(req, xml.encode("utf8"))
    result = handle.read()

    
def reverse(ID):
    c = getContent(ID)
    dom = parse(StringIO.StringIO(c))

    tags = dom.getElementsByTagName("tag")
    if len(tags) != 2:
        print "Error1", ID

    d = {}
    for tag in tags:
        d[tag.attributes.get("k").value] = tag.attributes.get("v").value
        
    if d["landuse"] != "forest":
        print "Error2", ID
    if d["source"] != "uhul:wms":
        print "Error3", ID
        
    for way in dom.getElementsByTagName("way"):
        refs = []
        for nd in way.getElementsByTagName("nd"):
            refs.append(nd.attributes.get("ref").value)

        refs.reverse()
        for (i, nd) in enumerate(way.getElementsByTagName("nd")):
            nd.attributes.get("ref").value = refs[i]

    #print dom.toxml()
    sendResult(ID, dom.toxml())
    
def repairLesy():
    completed = set()
    f = open("completed.txt", "rb")
    rows = f.read().split("\n")
    f.close()
    for row in rows:
        row = row.strip()
        if not row:
            continue
        completed.add(int(row))

    nums = set()
    f = open("out.txt", "rb")
    rows = f.read().split("\n")
    f.close()
    for row in rows:
        row = row.strip()
        if not row:
            continue
        if "Do clockwise:" not in row and "Do anticlockwise:" not in row:
            continue
        num = int(row.split(" ")[2])
        nums.add(num)
        
    for num in nums:
        if num in completed:
            continue
        #print num
        try:
            reverse(num)
        except Exception, e:
            print num, e
            continue
        completed.add(num)
        f = open("completed.txt", "ab")
        print >> f, str(num)
        f.close()
        print "Completed: ID=%d %d/%d" % (num, len(completed), len(nums))
        #break

def main():
    repairLesy()

if __name__ == '__main__':
    main()
